Index: source/ps/scripting/JSInterface_VFS.cpp
===================================================================
--- source/ps/scripting/JSInterface_VFS.cpp	(Revision 14461)
+++ source/ps/scripting/JSInterface_VFS.cpp	(Arbeitskopie)
@@ -19,9 +19,10 @@
 
 #include <sstream>
 
+#include "ps/CLogger.h"
 #include "ps/CStr.h"
 #include "ps/Filesystem.h"
-#include "scripting/ScriptingHost.h"
+#include "scriptinterface/ScriptVal.h"
 #include "scriptinterface/ScriptInterface.h"
 #include "ps/scripting/JSInterface_VFS.h"
 #include "lib/file/vfs/vfs_util.h"
@@ -31,13 +32,11 @@
 	/* this is liable to happen often, so don't complain */\
 	if (err == ERR::VFS_FILE_NOT_FOUND)\
 	{\
-		JS_SET_RVAL(cx, vp, JSVAL_NULL);\
-		return JS_TRUE;\
+		return 0; \
 	}\
-	/* unknown failure. we return an error (akin to an exception in JS) that
-	   stops the script to make sure this error is noticed. */\
+	/* unknown failure. We output an error message. */\
 	else if (err < 0)\
-		return JS_FALSE;\
+		LOGERROR(L"Unknown failure in VFS %i", err );
 	/* else: success */
 
 
@@ -85,61 +84,30 @@
 //
 // note: full pathnames of each file/subdirectory are returned,
 // ready for use as a "filename" for the other functions.
-JSBool JSI_VFS::BuildDirEntList(JSContext* cx, uintN argc, jsval* vp)
+CScriptVal JSI_VFS::BuildDirEntList(ScriptInterface::CxPrivate* pCxPrivate, std::wstring path, std::wstring filterStr, bool recurse)
 {
-	//
-	// get arguments
-	//
-
-	JSU_REQUIRE_PARAM_RANGE(1, 3);
-
-	CStrW path;
-	if (!ScriptInterface::FromJSVal(cx, JS_ARGV(cx, vp)[0], path))
-		return JS_FALSE;
-
-	CStrW filter_str = L"";
-	if (argc >= 2)
-	{
-		if (!ScriptInterface::FromJSVal(cx, JS_ARGV(cx, vp)[1], filter_str))
-			return JS_FALSE;
-	}
 	// convert to const wchar_t*; if there's no filter, pass 0 for speed
 	// (interpreted as: "accept all files without comparing").
 	const wchar_t* filter = 0;
-	if (!filter_str.empty())
-		filter = filter_str.c_str();
+	if (!filterStr.empty())
+		filter = filterStr.c_str();
+ 
+	int flags = recurse ? vfs::DIR_RECURSIVE : 0;
 
-	bool recursive = false;
-	if (argc >= 3)
-	{
-		if (!ScriptInterface::FromJSVal(cx, JS_ARGV(cx, vp)[2], recursive))
-			return JS_FALSE;
-	}
-	int flags = recursive ? vfs::DIR_RECURSIVE : 0;
-
-
 	// build array in the callback function
-	BuildDirEntListState state(cx);
+	BuildDirEntListState state(pCxPrivate->pScriptInterface->GetContext());
 	vfs::ForEachFile(g_VFS, path, BuildDirEntListCB, (uintptr_t)&state, filter, flags);
 
-	JS_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(state.filename_array));
-	return JS_TRUE;
+	return OBJECT_TO_JSVAL(state.filename_array);
 }
 
 // Return true iff the file exits
 //
 // if (fileExists(filename)) { ... }
 //   filename: VFS filename (may include path)
-JSBool JSI_VFS::FileExists(JSContext* cx, uintN argc, jsval* vp)
+bool JSI_VFS::FileExists(ScriptInterface::CxPrivate* UNUSED(pCxPrivate), CStrW filename)
 {
-	JSU_REQUIRE_PARAMS(1);
-
-	CStrW filename;
-	if (!ScriptInterface::FromJSVal<CStrW> (cx, JS_ARGV(cx, vp)[0], filename))
-		return JS_FALSE;
-
-	JS_SET_RVAL(cx, vp, g_VFS->GetFileInfo(filename, 0) == INFO::OK ? JSVAL_TRUE : JSVAL_FALSE);
-	return JS_TRUE;
+	return (g_VFS->GetFileInfo(filename, 0) == INFO::OK);
 }
 
 
@@ -147,20 +115,13 @@
 //
 // mtime = getFileMTime(filename);
 //   filename: VFS filename (may include path)
-JSBool JSI_VFS::GetFileMTime(JSContext* cx, uintN argc, jsval* vp)
+double JSI_VFS::GetFileMTime(ScriptInterface::CxPrivate* UNUSED(pCxPrivate), std::wstring filename)
 {
-	JSU_REQUIRE_PARAMS(1);
-
-	CStrW filename;
-	if (!ScriptInterface::FromJSVal(cx, JS_ARGV(cx, vp)[0], filename))
-		return JS_FALSE;
-
 	CFileInfo fileInfo;
 	Status err = g_VFS->GetFileInfo(filename, &fileInfo);
 	JS_CHECK_FILE_ERR(err);
 
-	JS_SET_RVAL(cx, vp, ScriptInterface::ToJSVal(cx, (double)fileInfo.MTime()));
-	return JS_TRUE;
+	return (double)fileInfo.MTime();
 }
 
 
@@ -168,20 +129,13 @@
 //
 // size = getFileSize(filename);
 //   filename: VFS filename (may include path)
-JSBool JSI_VFS::GetFileSize(JSContext* cx, uintN argc, jsval* vp)
+unsigned int JSI_VFS::GetFileSize(ScriptInterface::CxPrivate* UNUSED(pCxPrivate), std::wstring filename)
 {
-	JSU_REQUIRE_PARAMS(1);
-
-	CStrW filename;
-	if (!ScriptInterface::FromJSVal(cx, JS_ARGV(cx, vp)[0], filename))
-		return JS_FALSE;
-
 	CFileInfo fileInfo;
 	Status err = g_VFS->GetFileInfo(filename, &fileInfo);
 	JS_CHECK_FILE_ERR(err);
 
-	JS_SET_RVAL(cx, vp, ScriptInterface::ToJSVal(cx, (unsigned)fileInfo.Size()));
-	return JS_TRUE;
+	return (unsigned int)fileInfo.Size();
 }
 
 
@@ -189,23 +143,11 @@
 //
 // contents = readFile(filename);
 //   filename: VFS filename (may include path)
-JSBool JSI_VFS::ReadFile(JSContext* cx, uintN argc, jsval* vp)
+CScriptVal JSI_VFS::ReadFile(ScriptInterface::CxPrivate* pCxPrivate, std::wstring filename)
 {
-	JSU_REQUIRE_PARAMS(1);
-
-	CStrW filename;
-	if (!ScriptInterface::FromJSVal(cx, JS_ARGV(cx, vp)[0], filename))
-		return JS_FALSE;
-
-	//
-	// read file
-	//
 	CVFSFile file;
 	if (file.Load(g_VFS, filename) != PSRETURN_OK)
-	{
-		JS_SET_RVAL(cx, vp, JSVAL_NULL);
-		return JS_TRUE;
-	}
+		return JSVAL_NULL;
 
 	CStr contents = file.DecodeUTF8(); // assume it's UTF-8
 
@@ -213,8 +155,7 @@
 	contents.Replace("\r\n", "\n");
 
 	// Decode as UTF-8
-	JS_SET_RVAL(cx, vp, ScriptInterface::ToJSVal(cx, contents.FromUTF8()));
-	return JS_TRUE;
+	return ScriptInterface::ToJSVal( pCxPrivate->pScriptInterface->GetContext(), contents.FromUTF8() );
 }
 
 
@@ -222,23 +163,14 @@
 //
 // lines = readFileLines(filename);
 //   filename: VFS filename (may include path)
-JSBool JSI_VFS::ReadFileLines(JSContext* cx, uintN argc, jsval* vp)
+CScriptVal JSI_VFS::ReadFileLines(ScriptInterface::CxPrivate* pCxPrivate, std::wstring filename)
 {
-	JSU_REQUIRE_PARAMS(1);
-
-	CStrW filename;
-	if (!ScriptInterface::FromJSVal(cx, JS_ARGV(cx, vp)[0], filename))
-		return (JS_FALSE);
-
 	//
 	// read file
 	//
 	CVFSFile file;
 	if (file.Load(g_VFS, filename) != PSRETURN_OK)
-	{
-		JS_SET_RVAL(cx, vp, JSVAL_NULL);
-		return JS_TRUE;
-	}
+		return JSVAL_NULL;
 
 	CStr contents = file.DecodeUTF8(); // assume it's UTF-8
 
@@ -251,6 +183,7 @@
 
 	std::stringstream ss(contents);
 
+	JSContext* cx = pCxPrivate->pScriptInterface->GetContext();
 	JSObject* line_array = JS_NewArrayObject(cx, 0, NULL);
 
 	std::string line;
@@ -262,6 +195,5 @@
 		JS_SetElement(cx, line_array, cur_line++, &val);
 	}
 
-	JS_SET_RVAL(cx, vp, OBJECT_TO_JSVAL( line_array ));
-	return JS_TRUE ;
+	return OBJECT_TO_JSVAL( line_array );
 }
Index: source/ps/scripting/JSInterface_ConfigDB.h
===================================================================
--- source/ps/scripting/JSInterface_ConfigDB.h	(Revision 14461)
+++ source/ps/scripting/JSInterface_ConfigDB.h	(Arbeitskopie)
@@ -18,18 +18,17 @@
 #ifndef INCLUDED_JSI_CONFIGDB
 #define INCLUDED_JSI_CONFIGDB
 
+#include "scriptinterface/ScriptInterface.h"
 #include "ps/ConfigDB.h"
 
-class ScriptInterface;
-
 namespace JSI_ConfigDB
 {
 	bool GetConfigNamespace(std::wstring cfgNsString, EConfigNamespace& cfgNs);
-	std::string GetValue(void* cbdata, std::wstring cfgNsString, std::string name);
-	bool CreateValue(void* cbdata, std::wstring cfgNsString, std::string name, std::string value);
-	bool WriteFile(void* cbdata, std::wstring cfgNsString, Path path);
-	bool Reload(void* cbdata, std::wstring cfgNsString);
-	bool SetFile(void* cbdata, std::wstring cfgNsString, Path path);
+	std::string GetValue(ScriptInterface::CxPrivate* pCxPrivate, std::wstring cfgNsString, std::string name);
+	bool CreateValue(ScriptInterface::CxPrivate* pCxPrivate, std::wstring cfgNsString, std::string name, std::string value);
+	bool WriteFile(ScriptInterface::CxPrivate* pCxPrivate, std::wstring cfgNsString, Path path);
+	bool Reload(ScriptInterface::CxPrivate* pCxPrivate, std::wstring cfgNsString);
+	bool SetFile(ScriptInterface::CxPrivate* pCxPrivate, std::wstring cfgNsString, Path path);
 	void RegisterScriptFunctions(ScriptInterface& scriptInterface);
 }
 
Index: source/ps/scripting/JSInterface_Console.cpp
===================================================================
--- source/ps/scripting/JSInterface_Console.cpp	(Revision 14461)
+++ source/ps/scripting/JSInterface_Console.cpp	(Arbeitskopie)
@@ -32,21 +32,21 @@
 	return true;
 }
 
-bool JSI_Console::GetVisibleEnabled(void* UNUSED(cbdata))
+bool JSI_Console::GetVisibleEnabled(ScriptInterface::CxPrivate* UNUSED(pCxPrivate))
 {
 	if (!CheckGlobalInitialized())
 		return false;
 	return g_Console->IsActive();
 }
 
-void JSI_Console::SetVisibleEnabled(void* UNUSED(cbdata), bool Enabled)
+void JSI_Console::SetVisibleEnabled(ScriptInterface::CxPrivate* UNUSED(pCxPrivate), bool Enabled)
 {
 	if (!CheckGlobalInitialized())
 		return;
 	g_Console->SetVisible(Enabled);
 }
 
-void JSI_Console::Write(void* UNUSED(cbdata), std::wstring output)
+void JSI_Console::Write(ScriptInterface::CxPrivate* UNUSED(pCxPrivate), std::wstring output)
 {
 	if (!CheckGlobalInitialized())
 		return;
Index: source/ps/scripting/JSInterface_VFS.h
===================================================================
--- source/ps/scripting/JSInterface_VFS.h	(Revision 14461)
+++ source/ps/scripting/JSInterface_VFS.h	(Arbeitskopie)
@@ -22,9 +22,9 @@
 #ifndef INCLUDED_JSI_VFS
 #define INCLUDED_JSI_VFS
 
-#include "scripting/ScriptingHost.h"
+#include "scriptinterface/ScriptInterface.h"
 
-// these are registered in ScriptGlue.cpp, hence the need for a header.
+// these are registered in ScriptFunctions.cpp, hence the need for a header.
 
 namespace JSI_VFS
 {
@@ -38,37 +38,37 @@
 	//
 	// note: full pathnames of each file/subdirectory are returned,
 	// ready for use as a "filename" for the other functions.
-	JSBool BuildDirEntList(JSContext* cx, uintN argc, jsval* vp);
+	CScriptVal BuildDirEntList(ScriptInterface::CxPrivate* pCxPrivate, std::wstring path, std::wstring filterStr, bool recurse);
 
 	// Return true iff the file exists
 	//
 	// if (fileExists(filename) { ... }
 	//   filename: VFS filename (may include path)
-	JSBool FileExists(JSContext* cx, uintN argc, jsval* vp);
+	bool FileExists(ScriptInterface::CxPrivate* pCxPrivate, CStrW filename);
 
 	// Return time [seconds since 1970] of the last modification to the specified file.
 	//
 	// mtime = getFileMTime(filename);
 	//   filename: VFS filename (may include path)
-	JSBool GetFileMTime(JSContext* cx, uintN argc, jsval* vp);
+	double GetFileMTime(ScriptInterface::CxPrivate* pCxPrivate, std::wstring filename);
 
 	// Return current size of file.
 	//
 	// size = getFileSize(filename);
 	//   filename: VFS filename (may include path)
-	JSBool GetFileSize(JSContext* cx, uintN argc, jsval* vp);
+	unsigned int GetFileSize(ScriptInterface::CxPrivate* pCxPrivate, std::wstring filename);
 
 	// Return file contents in a string.
 	//
 	// contents = readFile(filename);
 	//   filename: VFS filename (may include path)
-	JSBool ReadFile(JSContext* cx, uintN argc, jsval* vp);
+	CScriptVal ReadFile(ScriptInterface::CxPrivate* pCxPrivate, std::wstring filename);
 
 	// Return file contents as an array of lines.
 	//
 	// lines = readFileLines(filename);
 	//   filename: VFS filename (may include path)
-	JSBool ReadFileLines(JSContext* cx, uintN argc, jsval* vp);
+	CScriptVal ReadFileLines(ScriptInterface::CxPrivate* pCxPrivate, std::wstring filename);
 }
 
 #endif
Index: source/ps/scripting/JSInterface_Console.h
===================================================================
--- source/ps/scripting/JSInterface_Console.h	(Revision 14461)
+++ source/ps/scripting/JSInterface_Console.h	(Arbeitskopie)
@@ -23,9 +23,9 @@
 namespace JSI_Console
 {
 	bool CheckGlobalInitialized();
-	bool GetVisibleEnabled(void* cbdata);
-	void SetVisibleEnabled(void* cbdata, bool Enabled);
-	void Write(void* cbdata, std::wstring output);
+	bool GetVisibleEnabled(ScriptInterface::CxPrivate* pCxPrivate);
+	void SetVisibleEnabled(ScriptInterface::CxPrivate* pCxPrivate, bool Enabled);
+	void Write(ScriptInterface::CxPrivate* pCxPrivate, std::wstring output);
 	
 	void RegisterScriptFunctions(ScriptInterface& scriptInterface);
 }
Index: source/ps/scripting/JSInterface_ConfigDB.cpp
===================================================================
--- source/ps/scripting/JSInterface_ConfigDB.cpp	(Revision 14461)
+++ source/ps/scripting/JSInterface_ConfigDB.cpp	(Arbeitskopie)
@@ -42,7 +42,7 @@
 	return true;
 }
 
-std::string JSI_ConfigDB::GetValue(void* UNUSED(cbdata), std::wstring cfgNsString, std::string name)
+std::string JSI_ConfigDB::GetValue(ScriptInterface::CxPrivate* UNUSED(pCxPrivate), std::wstring cfgNsString, std::string name)
 {
 	EConfigNamespace cfgNs;
 	if (!GetConfigNamespace(cfgNsString, cfgNs))
@@ -53,7 +53,7 @@
 	return value;
 }
 
-bool JSI_ConfigDB::CreateValue(void* UNUSED(cbdata), std::wstring cfgNsString, std::string name, std::string value)
+bool JSI_ConfigDB::CreateValue(ScriptInterface::CxPrivate* UNUSED(pCxPrivate), std::wstring cfgNsString, std::string name, std::string value)
 {
 	EConfigNamespace cfgNs;
 	if (!GetConfigNamespace(cfgNsString, cfgNs))
@@ -63,7 +63,7 @@
 	return true;
 }
 
-bool JSI_ConfigDB::WriteFile(void* UNUSED(cbdata), std::wstring cfgNsString, Path path)
+bool JSI_ConfigDB::WriteFile(ScriptInterface::CxPrivate* UNUSED(pCxPrivate), std::wstring cfgNsString, Path path)
 {
 	EConfigNamespace cfgNs;
 	if (!GetConfigNamespace(cfgNsString, cfgNs))
@@ -73,7 +73,7 @@
 	return ret;
 }
 
-bool JSI_ConfigDB::Reload(void* UNUSED(cbdata), std::wstring cfgNsString)
+bool JSI_ConfigDB::Reload(ScriptInterface::CxPrivate* UNUSED(pCxPrivate), std::wstring cfgNsString)
 {
 	EConfigNamespace cfgNs;
 	if (!GetConfigNamespace(cfgNsString, cfgNs))
@@ -83,7 +83,7 @@
 	return ret;
 }
 
-bool JSI_ConfigDB::SetFile(void* UNUSED(cbdata), std::wstring cfgNsString, Path path)
+bool JSI_ConfigDB::SetFile(ScriptInterface::CxPrivate* UNUSED(pCxPrivate), std::wstring cfgNsString, Path path)
 {
 	EConfigNamespace cfgNs;
 	if (!GetConfigNamespace(cfgNsString, cfgNs))
Index: source/ps/CConsole.cpp
===================================================================
--- source/ps/CConsole.cpp	(Revision 14461)
+++ source/ps/CConsole.cpp	(Arbeitskopie)
@@ -28,6 +28,7 @@
 #include "graphics/ShaderManager.h"
 #include "graphics/TextRenderer.h"
 #include "gui/GUIutil.h"
+#include "gui/GUIManager.h"
 #include "lib/ogl.h"
 #include "lib/sysdep/clipboard.h"
 #include "lib/timer.h"
@@ -40,7 +41,6 @@
 #include "ps/Hotkey.h"
 #include "ps/Pyrogenesis.h"
 #include "renderer/Renderer.h"
-#include "scripting/ScriptingHost.h"
 #include "scriptinterface/ScriptInterface.h"
 
 CConsole* g_Console = 0;
@@ -603,10 +603,11 @@
 	               // a crash it's a useful record.
 
 	// Process it as JavaScript
-
-	jsval rval = g_ScriptingHost.ExecuteScript(szLine, L"Console");
-	if (!JSVAL_IS_VOID(rval))
-		InsertMessage(L"%ls", g_ScriptingHost.GetScriptInterface().ToString(rval).c_str());
+	
+	CScriptVal rval;
+	g_GUI->GetActiveGUI()->GetScriptInterface()->Eval(szLine, rval);
+	if (!rval.undefined())
+		InsertMessage(L"%ls", g_GUI->GetActiveGUI()->GetScriptInterface()->ToString(rval.get()).c_str());
 }
 
 void CConsole::LoadHistory()
Index: source/ps/Replay.cpp
===================================================================
--- source/ps/Replay.cpp	(Revision 14461)
+++ source/ps/Replay.cpp	(Arbeitskopie)
@@ -127,6 +127,7 @@
 	new CProfileManager;
 	g_ScriptStatsTable = new CScriptStatsTable;
 	g_ProfileViewer.AddRootTable(g_ScriptStatsTable);
+	g_ScriptRuntime = ScriptInterface::CreateRuntime(128 * 1024 * 1024);
 
 	CGame game(true);
 	g_Game = &game;
Index: source/soundmanager/SoundManager.h
===================================================================
--- source/soundmanager/SoundManager.h	(Revision 14461)
+++ source/soundmanager/SoundManager.h	(Arbeitskopie)
@@ -108,7 +108,6 @@
 	void StartPlayList( bool doLoop );
 	void AddPlayListItem(const VfsPath& itemPath);
 
-	static void ScriptingInit();
 	static void CreateSoundManager();
 	static void SetEnabled(bool doEnable);
 	static Status ReloadChangedFileCB(void* param, const VfsPath& path);
Index: source/soundmanager/scripting/JSInterface_Sound.cpp
===================================================================
--- source/soundmanager/scripting/JSInterface_Sound.cpp	(Revision 14461)
+++ source/soundmanager/scripting/JSInterface_Sound.cpp	(Arbeitskopie)
@@ -31,55 +31,55 @@
 {
   #if CONFIG2_AUDIO
 
-  void StartMusic(void* UNUSED(cbdata))
+  void StartMusic(ScriptInterface::CxPrivate* UNUSED(pCxPrivate))
   {
     if ( CSoundManager* sndManager = (CSoundManager*)g_SoundManager )
       sndManager->SetMusicEnabled(true);
   }
 
-  void StopMusic(void* UNUSED(cbdata))
+  void StopMusic(ScriptInterface::CxPrivate* UNUSED(pCxPrivate))
   {
     if ( CSoundManager* sndManager = (CSoundManager*)g_SoundManager )
       sndManager->SetMusicEnabled(false);
   }
 
-  void ClearPlaylist(void* UNUSED(cbdata))
+  void ClearPlaylist(ScriptInterface::CxPrivate* UNUSED(pCxPrivate))
   {
     if ( CSoundManager* sndManager = (CSoundManager*)g_SoundManager )
       sndManager->ClearPlayListItems();
   }
 
-  void AddPlaylistItem(void* UNUSED(cbdata), std::wstring filename)
+  void AddPlaylistItem(ScriptInterface::CxPrivate* UNUSED(pCxPrivate), std::wstring filename)
   {  
     if ( CSoundManager* sndManager = (CSoundManager*)g_SoundManager )
       sndManager->AddPlayListItem(VfsPath(filename));
   }
 
-  void StartPlaylist(void* UNUSED(cbdata), bool looping)
+  void StartPlaylist(ScriptInterface::CxPrivate* UNUSED(pCxPrivate), bool looping)
   {
     if ( CSoundManager* sndManager = (CSoundManager*)g_SoundManager )
       sndManager->StartPlayList( looping );
   }
 
-  void PlayMusic(void* UNUSED(cbdata), std::wstring filename, bool looping)
+  void PlayMusic(ScriptInterface::CxPrivate* UNUSED(pCxPrivate), std::wstring filename, bool looping)
   {
     if ( CSoundManager* sndManager = (CSoundManager*)g_SoundManager )
       sndManager->PlayAsMusic( filename, looping);
   }
 
-  void PlayUISound(void* UNUSED(cbdata), std::wstring filename, bool looping)
+  void PlayUISound(ScriptInterface::CxPrivate* UNUSED(pCxPrivate), std::wstring filename, bool looping)
   {
     if ( CSoundManager* sndManager = (CSoundManager*)g_SoundManager )
       sndManager->PlayAsUI( filename, looping);
   }
 
-  void PlayAmbientSound(void* UNUSED(cbdata), std::wstring filename, bool looping)
+  void PlayAmbientSound(ScriptInterface::CxPrivate* UNUSED(pCxPrivate), std::wstring filename, bool looping)
   {
     if ( CSoundManager* sndManager = (CSoundManager*)g_SoundManager )
       sndManager->PlayAsAmbient( filename, looping);
   }
 
-  bool MusicPlaying(void* UNUSED(cbdata))
+  bool MusicPlaying(ScriptInterface::CxPrivate* UNUSED(pCxPrivate))
   {
     return true;
   }
@@ -87,15 +87,15 @@
 
 
   #else
-    bool MusicPlaying(void* UNUSED(cbdata) ){ return false; }
-    void PlayAmbientSound(void* UNUSED(cbdata), std::wstring UNUSED(filename), bool UNUSED(looping) ){}
-    void PlayUISound(void* UNUSED(cbdata), std::wstring UNUSED(filename), bool UNUSED(looping) ) {}
-    void PlayMusic(void* UNUSED(cbdata), std::wstring UNUSED(filename), bool UNUSED(looping) ) {}
-    void StartPlaylist(void* UNUSED(cbdata), bool UNUSED(looping) ){}
-    void AddPlaylistItem(void* UNUSED(cbdata), std::wstring UNUSED(filename) ){}
-    void ClearPlaylist(void* UNUSED(cbdata) ){}
-    void StopMusic(void* UNUSED(cbdata) ){}
-    void StartMusic(void* UNUSED(cbdata) ){}
+	bool MusicPlaying(ScriptInterface::CxPrivate* UNUSED(pCxPrivate) ){ return false; }
+	void PlayAmbientSound(ScriptInterface::CxPrivate* UNUSED(pCxPrivate), std::wstring UNUSED(filename), bool UNUSED(looping) ){}
+	void PlayUISound(ScriptInterface::CxPrivate* UNUSED(pCxPrivate), std::wstring UNUSED(filename), bool UNUSED(looping) ) {}
+	void PlayMusic(ScriptInterface::CxPrivate* UNUSED(pCxPrivate), std::wstring UNUSED(filename), bool UNUSED(looping) ) {}
+	void StartPlaylist(ScriptInterface::CxPrivate* UNUSED(pCxPrivate), bool UNUSED(looping) ){}
+	void AddPlaylistItem(ScriptInterface::CxPrivate* UNUSED(pCxPrivate), std::wstring UNUSED(filename) ){}
+	void ClearPlaylist(ScriptInterface::CxPrivate* UNUSED(pCxPrivate) ){}
+	void StopMusic(ScriptInterface::CxPrivate* UNUSED(pCxPrivate) ){}
+	void StartMusic(ScriptInterface::CxPrivate* UNUSED(pCxPrivate) ){}
 
   #endif
 
Index: source/scriptinterface/ThreadDebugger.cpp
===================================================================
--- source/scriptinterface/ThreadDebugger.cpp	(Revision 14461)
+++ source/scriptinterface/ThreadDebugger.cpp	(Arbeitskopie)
@@ -289,10 +289,10 @@
 	ReturnActiveBreakPoints(NULL);
 
 	// Remove all the hooks because they store a pointer to this object
-	JS_SetExecuteHook(m->m_pScriptInterface->GetRuntime(), NULL, NULL);
-	JS_SetCallHook(m->m_pScriptInterface->GetRuntime(), NULL, NULL);
-	JS_SetNewScriptHook(m->m_pScriptInterface->GetRuntime(), NULL, NULL);
-	JS_SetDestroyScriptHook(m->m_pScriptInterface->GetRuntime(), NULL, NULL);
+	JS_SetExecuteHook(m->m_pScriptInterface->GetJSRuntime(), NULL, NULL);
+	JS_SetCallHook(m->m_pScriptInterface->GetJSRuntime(), NULL, NULL);
+	JS_SetNewScriptHook(m->m_pScriptInterface->GetJSRuntime(), NULL, NULL);
+	JS_SetDestroyScriptHook(m->m_pScriptInterface->GetJSRuntime(), NULL, NULL);
 }
 
 void CThreadDebugger::ReturnActiveBreakPoints(jsbytecode* pBytecode)
@@ -329,16 +329,16 @@
 	m->m_Name = name;
 	m->m_pScriptInterface = pScriptInterface;
 	m->m_pDebuggingServer = pDebuggingServer;
-	JS_SetExecuteHook(m->m_pScriptInterface->GetRuntime(), CallHook_, (void*)this);
-	JS_SetCallHook(m->m_pScriptInterface->GetRuntime(), CallHook_, (void*)this);
-	JS_SetNewScriptHook(m->m_pScriptInterface->GetRuntime(), NewScriptHook_, (void*)this);
-	JS_SetDestroyScriptHook(m->m_pScriptInterface->GetRuntime(), DestroyScriptHook_, (void*)this);
-	JS_SetThrowHook(m->m_pScriptInterface->GetRuntime(), ThrowHandler_, (void*)this);
+	JS_SetExecuteHook(m->m_pScriptInterface->GetJSRuntime(), CallHook_, (void*)this);
+	JS_SetCallHook(m->m_pScriptInterface->GetJSRuntime(), CallHook_, (void*)this);
+	JS_SetNewScriptHook(m->m_pScriptInterface->GetJSRuntime(), NewScriptHook_, (void*)this);
+	JS_SetDestroyScriptHook(m->m_pScriptInterface->GetJSRuntime(), DestroyScriptHook_, (void*)this);
+	JS_SetThrowHook(m->m_pScriptInterface->GetJSRuntime(), ThrowHandler_, (void*)this);
 	
 	if (m->m_pDebuggingServer->GetSettingSimultaneousThreadBreak())
 	{
 		// Setup a handler to check for break-requests from the DebuggingServer regularly
-		JS_SetInterrupt(m->m_pScriptInterface->GetRuntime(), CheckForBreakRequestHandler_, (void*)this);
+		JS_SetInterrupt(m->m_pScriptInterface->GetJSRuntime(), CheckForBreakRequestHandler_, (void*)this);
 	}
 }
 
@@ -456,7 +456,7 @@
 	
 	if (breakSrc == BREAK_SRC_INTERRUP)
 	{
-		JS_ClearInterrupt(m->m_pScriptInterface->GetRuntime(), NULL, NULL);
+		JS_ClearInterrupt(m->m_pScriptInterface->GetJSRuntime(), NULL, NULL);
 		JS_SetSingleStepMode(cx, script, false);
 	}
 	
@@ -496,17 +496,17 @@
 			{
 				if (nextDbgCmd == DBG_CMD_SINGLESTEP)
 				{
-					JS_SetInterrupt(m->m_pScriptInterface->GetRuntime(), StepHandler_, this);
+					JS_SetInterrupt(m->m_pScriptInterface->GetJSRuntime(), StepHandler_, this);
 					break;
 				}
 				else if (nextDbgCmd == DBG_CMD_STEPINTO)
 				{
-					JS_SetInterrupt(m->m_pScriptInterface->GetRuntime(), StepIntoHandler_, this);
+					JS_SetInterrupt(m->m_pScriptInterface->GetJSRuntime(), StepIntoHandler_, this);
 					break;
 				}
 				else if (nextDbgCmd == DBG_CMD_STEPOUT)
 				{
-					JS_SetInterrupt(m->m_pScriptInterface->GetRuntime(), StepOutHandler_, this);
+					JS_SetInterrupt(m->m_pScriptInterface->GetJSRuntime(), StepOutHandler_, this);
 					break;
 				}
 			}
@@ -518,7 +518,7 @@
 			else
 			{
 				// Setup a handler to check for break-requests from the DebuggingServer regularly
-				JS_SetInterrupt(m->m_pScriptInterface->GetRuntime(), CheckForBreakRequestHandler_, this);
+				JS_SetInterrupt(m->m_pScriptInterface->GetJSRuntime(), CheckForBreakRequestHandler_, this);
 			}
 			break;
 		}
Index: source/scriptinterface/ScriptInterface.h
===================================================================
--- source/scriptinterface/ScriptInterface.h	(Revision 14461)
+++ source/scriptinterface/ScriptInterface.h	(Arbeitskopie)
@@ -27,6 +27,25 @@
 
 #include "js/jsapi.h"
 
+#include "ps/Errors.h"
+ERROR_GROUP(Scripting);
+ERROR_TYPE(Scripting, SetupFailed);
+
+ERROR_SUBGROUP(Scripting, LoadFile);
+ERROR_TYPE(Scripting_LoadFile, OpenFailed);
+ERROR_TYPE(Scripting_LoadFile, EvalErrors);
+
+ERROR_TYPE(Scripting, ConversionFailed);
+ERROR_TYPE(Scripting, CallFunctionFailed);
+ERROR_TYPE(Scripting, RegisterFunctionFailed);
+ERROR_TYPE(Scripting, DefineConstantFailed);
+ERROR_TYPE(Scripting, CreateObjectFailed);
+ERROR_TYPE(Scripting, TypeDoesNotExist);
+
+ERROR_SUBGROUP(Scripting, DefineType);
+ERROR_TYPE(Scripting_DefineType, AlreadyExists);
+ERROR_TYPE(Scripting_DefineType, CreationFailed);
+
 #include "lib/file/vfs/vfs_path.h"
 #include "ps/Profile.h"
 #include "ps/utf16string.h"
@@ -47,6 +66,8 @@
 
 class ScriptRuntime;
 
+extern shared_ptr<ScriptRuntime> g_ScriptRuntime;
+
 class CDebuggingServer;
 
 /**
@@ -87,11 +108,18 @@
 	 */
 	static void ShutDown();
 
-	void SetCallbackData(void* cbdata);
-	static void* GetCallbackData(JSContext* cx);
+	struct CxPrivate
+	{
+		ScriptInterface* pScriptInterface; // the ScriptInterface object the current context belongs to
+		void* pCBData; // meant to be used as the "this" object for callback functions
+	} m_CxPrivate;
 
+	void SetCallbackData(void* pCBData);
+	static CxPrivate* GetScriptInterfaceAndCBData(JSContext* cx);
+
 	JSContext* GetContext() const;
-	JSRuntime* GetRuntime() const;
+	JSRuntime* GetJSRuntime() const;
+	shared_ptr<ScriptRuntime> GetRuntime() const;
 
 	/**
 	 * Load global scripts that most script contexts need,
@@ -170,6 +198,9 @@
 	template<typename T0, typename T1, typename T2, typename T3, typename R>
 	bool CallFunction(jsval val, const char* name, const T0& a0, const T1& a1, const T2& a2, const T3& a3, R& ret);
 
+	JSObject* CreateCustomObject(const std::string & typeName);
+	void DefineCustomObjectType(JSClass *clasp, JSNative constructor, uint minArgs, JSPropertySpec *ps, JSFunctionSpec *fs, JSPropertySpec *static_ps, JSFunctionSpec *static_fs);
+
 	jsval GetGlobalObject();
 
 	JSClass* GetGlobalClass();
@@ -268,7 +299,7 @@
 	 * @param code JS code to execute
 	 * @return true on successful compilation and execution; false otherwise
 	 */
-	bool LoadGlobalScript(const VfsPath& filename, const std::string& code);
+	bool LoadGlobalScript(const VfsPath& filename, const std::wstring& code);
 
 	/**
 	 * Load and execute the given script in the global scope.
@@ -342,8 +373,17 @@
 	static JSClass* GetClass(JSContext* cx, JSObject* obj);
 	static void* GetPrivate(JSContext* cx, JSObject* obj);
 
+	class CustomType
+	{
+	public:
+		JSObject *	m_Object;
+		JSClass *	m_Class;
+		JSNative 	m_Constructor;
+	};
 	void Register(const char* name, JSNative fptr, size_t nargs);
 	std::auto_ptr<ScriptInterface_impl> m;
+	
+	std::map<std::string, CustomType> m_CustomObjectTypes;
 
 // The nasty macro/template bits are split into a separate file so you don't have to look at them
 public:
Index: source/scriptinterface/NativeWrapperDecls.h
===================================================================
--- source/scriptinterface/NativeWrapperDecls.h	(Revision 14461)
+++ source/scriptinterface/NativeWrapperDecls.h	(Arbeitskopie)
@@ -40,7 +40,7 @@
 
 // Define RegisterFunction<TR, T0..., f>
 #define OVERLOADS(z, i, data) \
-	template <typename R, TYPENAME_T0_HEAD(z,i)  R (*fptr) ( void* T0_TAIL(z,i) )> \
+	template <typename R, TYPENAME_T0_HEAD(z,i)  R (*fptr) ( ScriptInterface::CxPrivate* T0_TAIL(z,i) )> \
 	void RegisterFunction(const char* name) { \
 		Register(name, call<R, T0_HEAD(z,i)  fptr>, nargs<0 T0_TAIL(z,i)>()); \
 	}
@@ -50,7 +50,7 @@
 // JSFastNative-compatible function that wraps the function identified in the template argument list
 // (Definition comes later, since it depends on some things we haven't defined yet)
 #define OVERLOADS(z, i, data) \
-	template <typename R, TYPENAME_T0_HEAD(z,i)  R (*fptr) ( void* T0_TAIL(z,i) )> \
+	template <typename R, TYPENAME_T0_HEAD(z,i)  R (*fptr) ( ScriptInterface::CxPrivate* T0_TAIL(z,i) )> \
 	static JSBool call(JSContext* cx, uintN argc, jsval* vp);
 BOOST_PP_REPEAT(SCRIPT_INTERFACE_MAX_ARGS, OVERLOADS, ~)
 #undef OVERLOADS
Index: source/scriptinterface/NativeWrapperDefns.h
===================================================================
--- source/scriptinterface/NativeWrapperDefns.h	(Revision 14461)
+++ source/scriptinterface/NativeWrapperDefns.h	(Arbeitskopie)
@@ -27,7 +27,7 @@
 	#define OVERLOADS(z, i, data) \
 		template<TYPENAME_T0_HEAD(z,i)  typename F> \
 		static void call(JSContext* cx, jsval& rval, F fptr  T0_A0(z,i)) { \
-			rval = ScriptInterface::ToJSVal<R>(cx, fptr(ScriptInterface::GetCallbackData(cx)  A0_TAIL(z,i))); \
+			rval = ScriptInterface::ToJSVal<R>(cx, fptr(ScriptInterface::GetScriptInterfaceAndCBData(cx) A0_TAIL(z,i))); \
 		}
 
 	BOOST_PP_REPEAT(SCRIPT_INTERFACE_MAX_ARGS, OVERLOADS, ~)
@@ -40,7 +40,7 @@
 	#define OVERLOADS(z, i, data) \
 		template<TYPENAME_T0_HEAD(z,i)  typename F> \
 		static void call(JSContext* cx, jsval& /*rval*/, F fptr  T0_A0(z,i)) { \
-			fptr(ScriptInterface::GetCallbackData(cx)  A0_TAIL(z,i)); \
+			fptr(ScriptInterface::GetScriptInterfaceAndCBData(cx) A0_TAIL(z,i)); \
 		}
 	BOOST_PP_REPEAT(SCRIPT_INTERFACE_MAX_ARGS, OVERLOADS, ~)
 	#undef OVERLOADS
@@ -90,7 +90,7 @@
 
 // JSFastNative-compatible function that wraps the function identified in the template argument list
 #define OVERLOADS(z, i, data) \
-	template <typename R, TYPENAME_T0_HEAD(z,i)  R (*fptr) ( void* T0_TAIL(z,i) )> \
+	template <typename R, TYPENAME_T0_HEAD(z,i)  R (*fptr) ( ScriptInterface::CxPrivate* T0_TAIL(z,i) )> \
 	JSBool ScriptInterface::call(JSContext* cx, uintN argc, jsval* vp) { \
 		UNUSED2(argc); \
 		SCRIPT_PROFILE \
Index: source/scriptinterface/ScriptStats.cpp
===================================================================
--- source/scriptinterface/ScriptStats.cpp	(Revision 14461)
+++ source/scriptinterface/ScriptStats.cpp	(Arbeitskopie)
@@ -86,28 +86,28 @@
 	{
 		if (col == 0)
 			return "max nominal heap bytes";
-		uint32_t n = JS_GetGCParameter(m_ScriptInterfaces.at(col-1).first->GetRuntime(), JSGC_MAX_BYTES);
+		uint32_t n = JS_GetGCParameter(m_ScriptInterfaces.at(col-1).first->GetJSRuntime(), JSGC_MAX_BYTES);
 		return CStr::FromUInt(n);
 	}
 	case Row_MaxMallocBytes:
 	{
 		if (col == 0)
 			return "max JS_malloc bytes";
-		uint32_t n = JS_GetGCParameter(m_ScriptInterfaces.at(col-1).first->GetRuntime(), JSGC_MAX_MALLOC_BYTES);
+		uint32_t n = JS_GetGCParameter(m_ScriptInterfaces.at(col-1).first->GetJSRuntime(), JSGC_MAX_MALLOC_BYTES);
 		return CStr::FromUInt(n);
 	}
 	case Row_Bytes:
 	{
 		if (col == 0)
 			return "allocated bytes";
-		uint32_t n = JS_GetGCParameter(m_ScriptInterfaces.at(col-1).first->GetRuntime(), JSGC_BYTES);
+		uint32_t n = JS_GetGCParameter(m_ScriptInterfaces.at(col-1).first->GetJSRuntime(), JSGC_BYTES);
 		return CStr::FromUInt(n);
 	}
 	case Row_NumberGC:
 	{
 		if (col == 0)
 			return "number of GCs";
-		uint32_t n = JS_GetGCParameter(m_ScriptInterfaces.at(col-1).first->GetRuntime(), JSGC_NUMBER);
+		uint32_t n = JS_GetGCParameter(m_ScriptInterfaces.at(col-1).first->GetJSRuntime(), JSGC_NUMBER);
 		return CStr::FromUInt(n);
 	}
 	default:
